//
//  JavenHotTagsModel.h
//
//  Created by Z  on 16/4/12
//  Copyright (c) 2016 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

@class JavenCategory, JavenLastModifyInfo, JavenCreateInfo;

@interface JavenHotTagsModel : NSObject <NSCoding, NSCopying>

@property (nonatomic, strong) NSString *domain;
@property (nonatomic, strong) JavenCategory *category;
@property (nonatomic, strong) JavenLastModifyInfo *lastModifyInfo;
@property (nonatomic, assign) double order;
@property (nonatomic, strong) NSString *uuid;
@property (nonatomic, strong) JavenCreateInfo *createInfo;
@property (nonatomic, assign) double version;
@property (nonatomic, strong) id internalBaseClassDescription;
@property (nonatomic, strong) NSString *name;

+ (instancetype)modelObjectWithDictionary:(NSDictionary *)dict;
- (instancetype)initWithDictionary:(NSDictionary *)dict;
- (NSDictionary *)dictionaryRepresentation;

@end
