//
//  CustomerDetailSectionHeader.m
//  ALand
//
//  Created by Z on 16/5/10.
//  Copyright © 2016年 Z. All rights reserved.
//

#import "CustomerDetailSectionHeader.h"

@interface CustomerDetailSectionHeader ()
@property (weak, nonatomic) IBOutlet UILabel *labelDate;
@property (weak, nonatomic) IBOutlet UILabel *labelState;

@end
@implementation CustomerDetailSectionHeader


- (void)viewWithModel:(JavenOrderModel *)model {
    self.labelDate.text = model.createInfo.time;
    
    NSArray *arrStateCode = @[@"toBePaid",@"toBeShipped",@"shipped",@"paid",@"cancelled"];
    NSArray *arrTitle = @[@"待支付",@"待发货",@"已发货",@"已完成",@"已取消"];
    
    for (int i = 0; i < arrStateCode.count; i++) {
        if ([arrStateCode[i] isEqualToString:model.state]) {
            self.labelState.text = arrTitle[i];
            break;
        }
    }
}
/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

@end
