//
//  OrderCellView.m
//  ALand
//
//  Created by Z on 16/3/30.
//  Copyright © 2016年 Z. All rights reserved.
//

#import "OrderCellView.h"
#import "JavenGoods.h"
@interface OrderCellView ()
@property (weak, nonatomic) IBOutlet UIImageView *imgCommdity;
@property (weak, nonatomic) IBOutlet UILabel *labelSpecName;
@property (weak, nonatomic) IBOutlet UILabel *labelCount;
@property (weak, nonatomic) IBOutlet UILabel *labelPrice;

@end
@implementation OrderCellView

- (void)setupViewWithModel:(JavenGoodsDetails *)model {
    
    JavenGoods *goods = model.goods;
    [self.imgCommdity sd_setImageWithURL:[NSURL URLWithString:goods.cover] placeholderImage:kPlaceHolderImage];
    self.labelTitle.text = goods.name;
    self.labelPrice.text = [NSString stringWithFormat:@"￥%.2f",goods.price];
    self.labelCount.text = [NSString stringWithFormat:@"x%.0f", model.count];
    
}

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

@end
