//
//  BankTableViewCell.m
//  ALand
//
//  Created by Z on 16/5/6.
//  Copyright © 2016年 Z. All rights reserved.
//

#import "BankTableViewCell.h"

@interface BankTableViewCell ()
@property (weak, nonatomic) IBOutlet UIImageView *imgViewBackground;
@property (weak, nonatomic) IBOutlet UILabel *labelBankName;
@property (weak, nonatomic) IBOutlet UILabel *labelBankNO;

@end
@implementation BankTableViewCell

- (void)cellWithModel:(JavenBankCards *)model {
    self.labelBankName.text = model.bank;
    self.labelBankNO.text = [NSString stringWithFormat:@"**** **** **** %@", [model.cardNo substringWithRange:NSMakeRange(model.cardNo.length - 4, 4)]];
}

- (void)awakeFromNib {
    // Initialization code
    self.imgViewBackground.layer.masksToBounds = YES;
    self.imgViewBackground.layer.cornerRadius = 8;
    self.selectionStyle = UITableViewCellSelectionStyleNone;
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];

    // Configure the view for the selected state
}

@end
