//
//  JavenResources.h
//
//  Created by Z  on 16/5/11
//  Copyright (c) 2016 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

@class JavenLastModifyInfo, JavenCreateInfo;

@interface JavenResources : NSObject <NSCoding, NSCopying>

@property (nonatomic, strong) NSString *domain;
@property (nonatomic, strong) NSString *upperPath;
@property (nonatomic, strong) JavenLastModifyInfo *lastModifyInfo;
@property (nonatomic, strong) NSString *uuid;
@property (nonatomic, strong) JavenCreateInfo *createInfo;
@property (nonatomic, assign) double version;
@property (nonatomic, strong) NSString *path;
@property (nonatomic, strong) NSString *name;
@property (nonatomic, strong) NSString *caption;

+ (instancetype)modelObjectWithDictionary:(NSDictionary *)dict;
- (instancetype)initWithDictionary:(NSDictionary *)dict;
- (NSDictionary *)dictionaryRepresentation;

@end
