//
//  UserInfoRoles.h
//
//  Created by Z  on 16/5/11
//  Copyright (c) 2016 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

@class UserInfoLastModifyInfo, UserInfoCreateInfo;

@interface UserInfoRoles : NSObject <NSCoding, NSCopying>

@property (nonatomic, strong) NSString *domain;
@property (nonatomic, strong) UserInfoLastModifyInfo *lastModifyInfo;
@property (nonatomic, assign) double order;
@property (nonatomic, strong) NSArray *resources;
@property (nonatomic, strong) NSString *uuid;
@property (nonatomic, strong) UserInfoCreateInfo *createInfo;
@property (nonatomic, assign) double version;
@property (nonatomic, strong) NSString *rolesDescription;
@property (nonatomic, strong) NSString *name;
@property (nonatomic, strong) NSString *state;

+ (instancetype)modelObjectWithDictionary:(NSDictionary *)dict;
- (instancetype)initWithDictionary:(NSDictionary *)dict;
- (NSDictionary *)dictionaryRepresentation;

@end
