//
//  CommotityListModel.h
//
//  Created by Z  on 16/4/27
//  Copyright (c) 2016 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "CommotityListCategory.h"
#import "CommotityListBrand.h"

@class CommotityListCategory, CommotityListBrand;

@interface CommotityListModel : NSObject <NSCoding, NSCopying>

@property (nonatomic, strong) NSString *uuid;
@property (nonatomic, strong) CommotityListCategory *category;
@property (nonatomic, assign) double salesVolume;
@property (nonatomic, assign) double visited;
@property (nonatomic, strong) CommotityListBrand *brand;
@property (nonatomic, strong) id engName;
@property (nonatomic, strong) NSString *pictures;
@property (nonatomic, assign) double price;
@property (nonatomic, assign) double originalPrice;
@property (nonatomic, strong) NSString *specName;
@property (nonatomic, assign) double favorited;
@property (nonatomic, strong) NSString *cover;
@property (nonatomic, assign) double commission;
@property (nonatomic, strong) NSString *tranferType;
@property (nonatomic, assign) double inv;
@property (nonatomic, strong) NSString *name;
@property (nonatomic, assign) double score;

+ (instancetype)modelObjectWithDictionary:(NSDictionary *)dict;
- (instancetype)initWithDictionary:(NSDictionary *)dict;
- (NSDictionary *)dictionaryRepresentation;

@end
