//
//  HomeTopView.m
//  ALand
//
//  Created by Z on 16/3/22.
//  Copyright © 2016年 Z. All rights reserved.
//

#import "HomeTopView.h"

@interface HomeTopView ()
@property (weak, nonatomic) IBOutlet UIImageView *imageBacround;
@property (weak, nonatomic) IBOutlet UIImageView *imageViewUserIcon;
@property (weak, nonatomic) IBOutlet UILabel *labelName;
@property (weak, nonatomic) IBOutlet UILabel *labelSubTitle;


@end

@implementation HomeTopView

- (void)awakeFromNib {
    self.imageViewUserIcon.layer.masksToBounds = YES;
    self.imageViewUserIcon.layer.cornerRadius = self.imageViewUserIcon.width / 2;
}

- (void)updateTopViewInfo:(JavenShopModel *)shop {
    [self.imageViewUserIcon sd_setImageWithURL:[NSURL URLWithString:shop.pictures] placeholderImage:kUserIconPlaceHolderImage];
    self.labelName.text = shop.name;
    self.labelSubTitle.text = shop.internalBaseClassDescription;
}
/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

@end
