//
//  OrderDetailTableViewCell.m
//  ALand
//
//  Created by Z on 16/4/1.
//  Copyright © 2016年 Z. All rights reserved.
//

#import "OrderDetailTableViewCell.h"
#import "JavenGoods.h"
@interface OrderDetailTableViewCell ()
@property (weak, nonatomic) IBOutlet UILabel *labelSpecName;
@property (weak, nonatomic) IBOutlet UILabel *labelCount;
@property (weak, nonatomic) IBOutlet UILabel *labelPrice;
@property (weak, nonatomic) IBOutlet UILabel *labelTitle;
@end
@implementation OrderDetailTableViewCell

- (void)awakeFromNib {
    self.selectionStyle = UITableViewCellSelectionStyleNone;
    // Initialization code
}


- (void)cellWithModel:(JavenGoodsDetails *)model {
    JavenGoods *goods = model.goods;
    [self.imgCommdity sd_setImageWithURL:[NSURL URLWithString:goods.cover] placeholderImage:kPlaceHolderImage];
    self.labelTitle.text = goods.name;
    self.labelPrice.text = [NSString stringWithFormat:@"￥%.2f",goods.price];
    self.labelCount.text = [NSString stringWithFormat:@"x%.0f", model.count];
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];


    // Configure the view for the selected state
}

@end
