//
//  OrderDetailTopView.h
//  ALand
//
//  Created by Z on 16/3/30.
//  Copyright © 2016年 Z. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "MBLabelWithFontAdapter.h"
#import "JavenOrderModel.h"
typedef NS_ENUM(NSInteger, ORDERTOPTYPE)
{
    ORDERTOPTYPE_NOPAYMENT,//代支付
    ORDERTOPTYPE_WAITFORDISPATCH,//待发货
    ORDERTOPTYPE_TRANSPORTED,//已发货
    ORDERTOPTYPE_COMMPLETE,//已完成
    ORDERTOPTYPE_CANCELED//已取消
};

@interface OrderDetailTopView : UIView
@property (nonatomic, assign) ORDERTOPTYPE orderType;
@property (weak, nonatomic) IBOutlet MBLabelWithFontAdapter *labelExpress;
@property (weak, nonatomic) IBOutlet UILabel *labelExpressTime;

@property (weak, nonatomic) IBOutlet UILabel *labelName;
@property (weak, nonatomic) IBOutlet UILabel *labelPhoneNumber;
@property (weak, nonatomic) IBOutlet UILabel *labelAddress;
@property (weak, nonatomic) IBOutlet UIView *bottomView;



@property (nonatomic) CGFloat viewHeight;
- (void)updateByOrderType;
- (void)updateHeight;

- (void)viewWithModel:(JavenOrderModel *)model;

@end
