//
//  JavenBillModel.h
//
//  Created by Z  on 16/5/16
//  Copyright (c) 2016 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "JavenConsumer.h"
#import "JavenLastModifyInfo.h"
#import "JavenOrder.h"
#import "JavenIncome.h"
#import "JavenCreateInfo.h"
@class JavenConsumer, JavenLastModifyInfo, JavenOrder, JavenIncome, JavenCreateInfo;

@interface JavenBillModel : NSObject <NSCoding, NSCopying>

@property (nonatomic, strong) NSString *uuid;
@property (nonatomic, strong) NSString *state;
@property (nonatomic, strong) id confirmDate;
@property (nonatomic, assign) double version;
@property (nonatomic, strong) JavenConsumer *consumer;
@property (nonatomic, strong) NSString *domain;
@property (nonatomic, strong) id refundFlowNum;
@property (nonatomic, strong) JavenLastModifyInfo *lastModifyInfo;
@property (nonatomic, strong) NSString *action;
@property (nonatomic, strong) JavenOrder *order;
@property (nonatomic, strong) JavenIncome *income;
@property (nonatomic, strong) id lowerReseller;
@property (nonatomic, strong) JavenCreateInfo *createInfo;
@property (nonatomic, strong) id remark;

+ (instancetype)modelObjectWithDictionary:(NSDictionary *)dict;
- (instancetype)initWithDictionary:(NSDictionary *)dict;
- (NSDictionary *)dictionaryRepresentation;

@end
