//
//  JavenResellerModel.h
//
//  Created by Z  on 16/5/11
//  Copyright (c) 2016 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "JavenOwnerOrg.h"
#import "JavenLastModifyInfo.h"
#import "JavenSocialContact.h"
#import "JavenCertificate.h"
#import "JavenPasswordControl.h"
#import "JavenRoles.h"
#import "JavenPostalAddresses.h"
#import "JavenIdCard.h"
#import "JavenReferrer.h"
#import "JavenShop.h"
#import "JavenCreateInfo.h"
#import "JavenLoginControl.h"


@interface JavenResellerBigModel : NSObject <NSCoding, NSCopying>

@property (nonatomic, assign) double birthday;
@property (nonatomic, strong) NSString *portrait;
@property (nonatomic, strong) JavenOwnerOrg *ownerOrg;
@property (nonatomic, strong) NSString *code;
@property (nonatomic, strong) NSString *telephone;
@property (nonatomic, strong) NSString *mobilephone;
@property (nonatomic, strong) NSString *uuid;
@property (nonatomic, strong) JavenLastModifyInfo *lastModifyInfo;
@property (nonatomic, strong) JavenSocialContact *socialContact;
@property (nonatomic, strong) JavenCertificate *certificate;
@property (nonatomic, assign) double version;
@property (nonatomic, strong) NSString *name;
@property (nonatomic, strong) NSString *invitationCode;
@property (nonatomic, strong) NSString *state;
@property (nonatomic, strong) NSString *domain;
//@property (nonatomic, strong) JavenPasswordControl *passwordControl;
@property (nonatomic, strong) NSString *gender;
@property (nonatomic, strong) NSArray *roles;
@property (nonatomic, strong) JavenPostalAddresses *postalAddresses;
@property (nonatomic, strong) JavenIdCard *idCard;
@property (nonatomic, strong) JavenReferrer *referrer;
@property (nonatomic, strong) JavenShop *shop;
@property (nonatomic, strong) JavenCreateInfo *createInfo;
@property (nonatomic, assign) double order;
@property (nonatomic, strong) JavenLoginControl *loginControl;
@property (nonatomic, strong) NSString *internalBaseClassDescription;

+ (instancetype)modelObjectWithDictionary:(NSDictionary *)dict;
- (instancetype)initWithDictionary:(NSDictionary *)dict;
- (NSDictionary *)dictionaryRepresentation;

@end
