//
//  UITableView+Category.m
//  ALand
//
//  Created by Z on 16/3/29.
//  Copyright © 2016年 Z. All rights reserved.
//

#import "UITableView+Category.h"

@implementation UITableView (Category)


+ (UITableView *)plainTableViewWithTarget:(id)target cellNibName:(NSString *)nibName cellId:(NSString *)cellId {
    UITableView *tableView = [[UITableView alloc] initWithFrame:CGRectZero style:UITableViewStylePlain];
    tableView.dataSource = target;
    tableView.delegate = target;
    [tableView registerNib:[UINib nibWithNibName:nibName bundle:[NSBundle mainBundle]] forCellReuseIdentifier:cellId];
    return tableView;
}


+ (UITableView *)groupedTableViewWithTarget:(id)target cellNibName:(NSString *)nibName cellId:(NSString *)cellId {
    UITableView *tableView = [[UITableView alloc] initWithFrame:CGRectZero style:UITableViewStyleGrouped];
    tableView.dataSource = target;
    tableView.delegate = target;
    [tableView registerNib:[UINib nibWithNibName:nibName bundle:[NSBundle mainBundle]] forCellReuseIdentifier:cellId];
    return tableView;
}
@end
