//
//  JavenBankCards.h
//
//  Created by Z  on 16/5/11
//  Copyright (c) 2016 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "JavenOwner.h"
#import "JavenAddress.h"


@interface JavenBankCards : NSObject <NSCoding, NSCopying>

@property (nonatomic, strong) JavenOwner *owner;
@property (nonatomic, strong) NSString *cardNo;
@property (nonatomic, strong) NSString *branchBank;
@property (nonatomic, strong) JavenAddress *address;
@property (nonatomic, strong) NSString *uuid;
@property (nonatomic, strong) NSString *bank;
@property (nonatomic, strong) NSString *carrier;

+ (instancetype)modelObjectWithDictionary:(NSDictionary *)dict;
- (instancetype)initWithDictionary:(NSDictionary *)dict;
- (NSDictionary *)dictionaryRepresentation;

@end
